/*
 * The contents of this file are subject to the terms 
 * of the Common Development and Distribution License 
 * (the License).  You may not use this file except in
 * compliance with the License.
 * 
 * You can obtain a copy of the license at 
 * https://glassfish.dev.java.net/public/CDDLv1.0.html or
 * glassfish/bootstrap/legal/CDDLv1.0.txt.
 * See the License for the specific language governing 
 * permissions and limitations under the License.
 * 
 * When distributing Covered Code, include this CDDL 
 * Header Notice in each file and include the License file 
 * at glassfish/bootstrap/legal/CDDLv1.0.txt.  
 * If applicable, add the following below the CDDL Header, 
 * with the fields enclosed by brackets [] replaced by
 * you own identifying information: 
 * "Portions Copyrighted [year] [name of copyright owner]"
 * 
 * Copyright 2006 Sun Microsystems, Inc. All rights reserved.
 */
 
/*
 * $Header: /cvs/glassfish/appserv-api/src/java/com/sun/appserv/management/config/JMSServiceConfig.java,v 1.1 2006/12/02 06:03:11 llc Exp $
 * $Revision: 1.1 $
 * $Date: 2006/12/02 06:03:11 $
 */

package com.sun.appserv.management.config;

import java.util.Map;

import com.sun.appserv.management.base.XTypes;
import com.sun.appserv.management.base.Container;


/**
	 Configuration for the &lt;jms-service&gt; element.
*/

public interface JMSServiceConfig
	extends ConfigElement, Container, PropertiesAccess
{
/** The j2eeType as returned by {@link com.sun.appserv.management.base.AMX#getJ2EEType}. */
	public static final String	J2EE_TYPE	= XTypes.JMS_SERVICE_CONFIG;

	public String	getAddressListBehavior();
	public void	    setAddressListBehavior( final String value );

	public String	getAddressListIterations();
	public void	    setAddressListIterations( final String value );

	public String	getDefaultJMSHost();
	public void	    setDefaultJMSHost( final String value );

	public String	getInitTimeoutInSeconds();
	public void	    setInitTimeoutInSeconds( final String value );

	public String	getMQScheme();
	public void	    setMQScheme( final String value );

	public String	getMQService();
	public void	    setMQService( final String value );

	public String	getReconnectAttempts();
	public void	    setReconnectAttempts( final String value );

	public boolean	getReconnectEnabled();
	public void	    setReconnectEnabled( final boolean value );

	public String	getReconnectIntervalInSeconds();
	public void	    setReconnectIntervalInSeconds( final String value );

	public String	getStartArgs();
	public void	    setStartArgs( final String value );

	public String	getType();
	public void	    setType( final String value );
	
	/**
		Calls Container.getContaineeMap( XTypes.JMS_HOST_CONFIG ).
		@return Map of JMSHostConfig MBean proxies, keyed by name.
		@see com.sun.appserv.management.base.Container#getContaineeMap
	 */
	public Map<String,JMSHostConfig>			getJMSHostConfigMap();
	/**
		Creates a new jms-host element.

		@param name The name (id) of the jms-host.
		@param optional A map of optional params keyed on the attribute keys
		defined here. (eg:- HOST_KEY).
		@return A proxy to the JMSHostConfig MBean.
		@see JMSHostConfigKeys
	 */
	public JMSHostConfig	createJMSHostConfig( String name, Map<String,String> optional );

	/**
		Removes a jms-host element.

		@param name The name (id) of the jms-host.
	 */
	public void			removeJMSHostConfig( String name );
}






